<?
/*
	Dev info, see: http://rsscloud.org/walkthrough.html
*/
class NP_RealTimePub extends NucleusPlugin {

	function getName() { return 'RealTimePub'; }
	function getAuthor()  { return 'Edmond Hui (admun)'; }
	function getURL() { return 'http://edmondhui.homeip.net/nudn'; }
	function getVersion() { return 'v0.1'; }
	function getDescription() {
		return 'This plugin adds real-time publish notification capacity to NucluesCMS. Supported protocols are: RSSCloud (more to come)';
	}

	function getEventList() {
		return array('PostAddItem');
	}

	function supportsFeature($what) {
		switch($what) {
			case 'SqlTablePrefix':
				return 1;
				break;
			default:
				return 0;
				break;
		}
	}

	function install() {
		$this->createOption('cloudHost',   'RSS cloud element domain', 'text', 'rpc.rsscloud.org');
		$this->createOption('cloudPort',   'RSS cloud port', 'text', '5337');
		$this->createOption('cloudPath',   'RSS cloud path', 'text', '/rsscloud/pleaseNotify');
		$this->createOption('pingHost',   'RSS cloud ping hostname', 'text', 'rpc.rsscloud.org');
		$this->createOption('pingPort',   'RSS cloud ping port', 'text', '5337');
		$this->createOption('pingPath',   'RSS cloud ping path', 'text', '/RPC2');
	}

	function doSkinVar($skinType) {
		echo '<cloud domain="'.$this->getOption('cloudHost').'" port="'.$this->getOption('cloudPort').'" path="'.$this->getOption('cloudPath').'" registerProcedure="" protocol="http-post" />';
	}

	function event_PostAddItem() {
		global $CONF;
		$parsed_url = parse_url('http://'.$this->getOption('pingHost').':'.$this->getOption('pingPort').$this->getOption('pingPath'));

		if ($parsed_url['host'] != '' && $parsed_url['port'] != '') {
			$content = '<?xml version="1.0"?>
					<methodCall>
					   <methodName>rssCloud.ping</methodName>
					   <params>
					      <param>
						 <value>'.$CONF['IndexURL'].'xml-rss2.php</value>
					      </param>
					   </params>
					</methodCall>';

			$request  = "POST {$parsed_url['path']} HTTP/1.1\r\n";
			$request .= "Accept: */*\r\n";
			$request .= "User-Agent: NucleusCMS NP_RealTimePub plugin\r\n";
			$request .= "Host: " . $parsed_url['host'] . ":" . $parsed_url['port'] . "\r\n";
			$request .= "Cache-Control: no-cache\r\n";
			$request .= "Content-Length: " . strlen( $content ) . "\r\n";
			$request .= "Content-Type: application/x-www-form-urlencoded; charset="._CHARSET."\r\n";
			$request .= "Connection: Close\r\n";
			$request .= "\r\n";
			$request .= $content;
				
			$result = '';

			$socket = fsockopen( $parsed_url['host'], $parsed_url['port'], $errno, $errstr);
			if ( $socket ) {
				fputs($socket, $request);
					
				while (!feof($socket)) {
					$result .= fgets($socket, 4096);
				}
					
				fclose($socket);
			}
		} else {
			$result = 'Error: incorrect ping server';
		}

		if (!substr("200 OK Connection: close", $result)) {
			ACTIONLOG::add(WARNING, 'RealTimePub ping error: ' . $result);
		}
	}
}
?> 
